<?php
namespace PME\Controllers\Custo;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class CustoPlanejadoRealizadoController extends \Zeedhi\Framework\Controller\Report {
  protected $entityManager;
  protected $birtStrategy;
  protected $environment;
  protected $newCode;
  protected $connection;
  protected $lista;
  protected $ConsumoPlanejadoRealizadoController;
  protected $utilities;

  public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $environment, $newCode, $connection, $lista, $ConsumoPlanejadoRealizadoController, $utilities) {
    $this->entityManager = $entityManager;
    $this->birtStrategy  = $birtStrategy;
    $this->environment   = $environment;
    $this->newCode       = $newCode;
    $this->connection    = $connection;
    $this->lista = $lista;
    $this->ConsumoPlanejadoRealizadoController = $ConsumoPlanejadoRealizadoController;
    $this->utilities = $utilities;
    
    parent::__construct($reportService);
  }

  protected $reportMapping = array (
    'PME01100' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "DTDE"            => "P_DTINICIAL",
        "DTATE"           => "P_DTFINAL",
        "NMTIPOCUSTOPLAN" => "P_NMTIPOCUSTO",
        "NMTIPOCUSTOREAL" => "P_NMTIPOCUSTOREAL",
        "TAMACNIVEL"      => "P_NRTAMACNIVEL",
        "NIVEL"           => "P_NIVEL",
        "CDFILCENTPME"    => "P_CDFILCENTPME",
        "LISTASERV"       => "P_LISTASERVICO", 
        "LISTACARD"       => "P_LISTATIPOCARD", 
        "CDTIPOCUSTOPLAN" => "P_NRTIPOCUSTO",
        "ESTOCAVEIS"      => "P_IDESTOCAVEIS",
        "NRCONSPLAN"      => "P_NRCONSPLAN", 
        "NRLISTAFILI"     => "P_NRLISTAFILI", 
        "NAOESTOCAVEIS"   => "P_IDNESTOCAVEIS",
        "CDTIPOCUSTOREAL" => "P_NRTIPOCUSTO_REAL",
        "DTMESINIC"       => "P_DTMESINIC",
        "DTMESFINA"       => "P_DTMESFINA",
        "NRORG"           => "P_NRORG",
        "AGRUPMASK"       => "P_MASCAGRUP",
        "DIFQTD"          => "P_IDDIFERENCA"
      )
    ),
    'PME01101' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "CDGRUPFILI"      => "P_CDGRUPFILI",
        "NMGRUPFILI"      => "P_NMGRUPFILI",     
        "DTDE"            => "P_DTINICIAL",
        "DTATE"           => "P_DTFINAL",
        "NMTIPOCUSTOPLAN" => "P_NMTIPOCUSTO",
        "NMTIPOCUSTOREAL" => "P_NMTIPOCUSTOREAL",
        "TAMACNIVEL"      => "P_NRTAMACNIVEL",
        "NIVEL"           => "P_NIVEL",
        "CDFILCENTPME"    => "P_CDFILCENTPME",
        "CDFILIAL"        => "P_CDFILIAL",
        "LISTACARD"       => "P_LISTATIPOCARD", 
        "LISTASERV"       => "P_LISTASERVICO", 
        "CDTIPOCUSTOPLAN" => "P_NRTIPOCUSTO",
        "ESTOCAVEIS"      => "P_IDESTOCAVEIS",
        "NRCONSPLAN"      => "P_NRCONSPLAN", 
        "NRLISTAFILI"     => "P_NRLISTAFILI", 
        "NAOESTOCAVEIS"   => "P_IDNESTOCAVEIS",
        "CDTIPOCUSTOREAL" => "P_NRTIPOCUSTO_REAL",
        "DTMESINIC"       => "P_DTMESINIC",
        "DTMESFINA"       => "P_DTMESFINA",  
        "DIFQTD"          => "P_IDDIFERENCA",
        "NRORG"           => "P_NRORG",
        "AGRUPMASK"       => "P_MASCAGRUP"
      )
    ),
    'PME01102' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "NRORG"           => "P_NRORG",
        "TAMACNIVEL"      => "P_NRTAMACNIVEL",
        "NIVEL"           => "P_NIVEL",
        "CDFILCENTPME"    => "P_CDFILCENTPME",
        "DTDE"            => "P_DTINICIAL",
        "DTATE"           => "P_DTFINAL",
        "LISTACARD"       => "P_LISTATIPOCARD", 
        "LISTASERV"       => "P_LISTASERVICO", 
        "CDTIPOCUSTOREAL" => "P_NRTIPOCUSTO_REAL",
        "ESTOCAVEIS"      => "P_IDESTOCAVEIS",
        "NRCONSPLAN"      => "P_NRCONSPLAN", 
        "NRLISTAFILI"     => "P_NRLISTAFILI", 
        "NAOESTOCAVEIS"   => "P_IDNESTOCAVEIS",
        "DTMESINIC"       => "P_DTMESINIC",
        "DTMESFINA"       => "P_DTMESFINA",  
        "AGRUPMASK"       => "P_MASCAGRUP",
        "NMTIPOCUSTOPLAN" => "P_NMTIPOCUSTO",
        "DIFQTD"          => "P_IDDIFERENCA",
        "CDTIPOCUSTOPLAN" => "P_NRTIPOCUSTO",
        "NMTIPOCUSTOREAL" => "P_NMTIPOCUSTOREAL"
      )
    ),
    'PME01103' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "TAMACNIVEL"      => "P_NRTAMACNIVEL",
        "NIVEL"           => "P_NIVEL",
        "CDFILCENTPME"    => "P_CDFILCENTPME",
        "DTDE"            => "P_DTINICIAL",
        "DTATE"           => "P_DTFINAL",
        "LISTACARD"       => "P_LISTATIPOCARD", 
        "LISTASERV"       => "P_LISTASERVICO", 
        "CDTIPOCUSTOREAL" => "P_NRTIPOCUSTO_REAL",
        "ESTOCAVEIS"      => "P_IDESTOCAVEIS",
        "NRCONSPLAN"      => "P_NRCONSPLAN", 
        "NRLISTAFILI"     => "P_NRLISTAFILI", 
        "NAOESTOCAVEIS"   => "P_IDNESTOCAVEIS",
        "NMTIPOCUSTOPLAN" => "P_NMTIPOCUSTO",
        "AGRUPMASK"       => "P_MASCAGRUP",
        "DIFQTD"          => "IDDIFERENCA",
        "NRORG"           => "P_NRORG",
        "CDTIPOCUSTOPLAN" => "P_NRTIPOCUSTO",
        "NMTIPOCUSTOREAL" => "P_NMTIPOCUSTOREAL"
      )
    ),
    'PME01104' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "DTDE"            => "P_DTINICIAL",
        "DTATE"           => "P_DTFINAL",
        "NMTIPOCUSTOPLAN" => "P_NMTIPOCUSTO",
        "NMTIPOCUSTOREAL" => "P_NMTIPOCUSTOREAL",
        "TAMACNIVEL"      => "P_NRTAMACNIVEL",
        "NIVEL"           => "P_NIVEL",
        "CDFILCENTPME"    => "P_CDFILCENTPME",
        "LISTACARD"       => "P_LISTATIPOCARD", 
        "LISTASERV"       => "P_LISTASERVICO", 
        "CDTIPOCUSTOPLAN" => "P_NRTIPOCUSTO",
        "ESTOCAVEIS"      => "P_IDESTOCAVEIS",
        "NRCONSPLAN"      => "P_NRCONSPLAN", 
        "NRLISTAFILI"     => "P_NRLISTAFILI", 
        "NAOESTOCAVEIS"   => "P_IDNESTOCAVEIS",
        "CDTIPOCUSTOREAL" => "P_NRTIPOCUSTO_REAL",
        "DTMESINIC"       => "P_DTMESINIC",
        "DTMESFINA"       => "P_DTMESFINA",
        "NRORG"           => "P_NRORG",
        "DIFQTD"          => "P_IDDIFERENCA",
      )
    )
  );
    
  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $rows = $request->getRow();
    $nrorg = $this->environment->getNrOrg();

    $rows['NRORG'] = $nrorg;
    $rows['NRCONSPLAN'] = $this->newCode->getCodeByTableName('CONSPLAN'.$rows['CDFILCENTPME'], $nrorg);
    
    $unidade = [];
    foreach($rows['UNIDADE'] as $row){
      $concatUnid = $row;
      array_push($unidade, $concatUnid);
    }
    
    $servico = [];
    foreach($rows['SERVICO'] as $row){
      $concatServ = $row['CDSERVFILI'];
      array_push($servico, $concatServ);
    }
    
    if ($rows['GRUPFILI'] == NULL){
      if(empty($rows['UNIDADE'])){
        $unid = $this->ConsumoPlanejadoRealizadoController->getUnidades($rows);
        $rows['NRLISTAFILI'] = $this->lista->geraLista($unid, $nrorg);
      } else $rows['NRLISTAFILI'] = $this->lista->geraLista(join("_", $unidade), $nrorg);
    } else if ($rows['GRUPFILI'] !== NULL){
      if(empty($rows['UNIDADE'])){
        $unid = $this->getUnidadesGrupoServ($rows, $nrorg);  
        $rows['NRLISTAFILI'] = $this->lista->geraLista($unid, $nrorg);
      } else {
        $rows['NRLISTAFILI'] = $this->lista->geraLista(join("_", $unidade), $nrorg);
      }
      if(empty($rows['CDSERVFILI'])) $rows['CDSERVFILI'] = null;
      else {
        $servicos = '';
        foreach($rows['CDSERVFILI'] as $serv) {
          $servicos .= $serv['CDSERVFILI'].'_';
        }
        $rows['CDSERVFILI'] = $servicos;
      }
    }
  
    $rows['LISTACARD'] = $this->geraListaTipoCard($rows, $nrorg);
    $rows['LISTASERV'] = $this->geraListaServico($rows, $nrorg);
    if (is_array($rows['UNIDADE'])) $rows['UNIDADE'] = join("_", $unidade);
    if (is_array($rows['CDSERVFILI'])) $rows['CDSERVFILI'] = join("_", $servico);
    $todasUnidades = $this->ConsumoPlanejadoRealizadoController->getUnidades($rows);
    $todosServicos = $this->ConsumoPlanejadoRealizadoController->getServicos($rows);
    $rows['CDFILIAL'] = is_array($rows['CDFILIAL']) ? $todasUnidades : $rows['UNIDADE'];
    $rows['CDSERVFILI'] = is_array($rows['CDSERVFILI']) ? implode($rows['CDSERVFILI']) : null;

    $this->ConsumoPlanejadoRealizadoController->procedure($rows);
    
    $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
    $this->birtStrategy->setReportFormat(strtolower($rows['reportFormat']));
  }
  
  
  public function geraListaTipoCard($rows, $nrorg) {
    $nrlista = $this->newCode->getCodeByTableName('LISTA_TIPOCARD', $rows['NRORG']);

    $sql = "INSERT INTO LISTA_TIPOCARD (NRLISTA, CDFILCENTPME, CDTIPOCARD, NMTIPOCARD, NRORG) VALUES (:NRLISTA, :CDFILCENTPME, :CDTIPOCARD, :NMTIPOCARD, :NRORG)";
    $cardapio = $rows['TIPOCARD'];
    
    if(count($cardapio) == 0){
      $result = $this->getCardapio($rows, $nrorg);
      $cardapio = $result;
    }

    foreach ($cardapio as $card) {
      $stmt = $this->entityManager->getConnection()->prepare($sql);
      $stmt->execute(
        array(
          "NRLISTA"      => $nrlista,
          "CDFILCENTPME" => $rows['CDFILCENTPME'],
          "CDTIPOCARD"   => $card['CDTIPOCARD'],
          "NMTIPOCARD"   => $card['NMTIPOCARD'],
          "NRORG"        => $nrorg
        )
      );
    }
    return $nrlista;
  }
  
  public function geraListaServico($rows, $nrorg) {
    $nrlista = $this->newCode->getCodeByTableName('LISTA_SERVICO', $rows['NRORG']);
    
    $sql = "INSERT INTO LISTA_SERVICO (NRLISTA, CDFILIAL, CDSERVFILI, NMSERVICO, CDGRUPSERV, NRORG) VALUES (:NRLISTA, :CDFILIAL, :CDSERVFILI, :NMSERVICO, :CDGRUPSERV, :NRORG)";
    $servicosFiliais = $rows['SERVICO'];
    
    if(count($servicosFiliais) == 0){
      $result = $this->getUnidServ($rows);
      $servicosFiliais = $result;
    }
    
    foreach ($servicosFiliais as $servicoFilial) {
      $stmt = $this->entityManager->getConnection()->prepare($sql);
      $stmt->execute(
        array(
          "NRLISTA"    => $nrlista,
          "CDFILIAL"   => $servicoFilial['CDFILIAL'],
          "NRORG"      => $rows['NRORG'],
          "CDSERVFILI" => $servicoFilial['CDSERVFILI'],
          "NMSERVICO"  => $servicoFilial['NMSERVICO'],
          "CDGRUPSERV" => $servicoFilial['CDGRUPSERV']
        )
      );
    }
    return $nrlista;
  }
  
  public function getUnidServ($rows){
    $nrorg = $this->environment->getNrOrg();
    
    $unidade = [];
    foreach($rows['UNIDADE'] as $row){
      $concatUnid = $row;
      array_push($unidade, $concatUnid);
    }
    
    if ($rows['GRUPFILI'] == NULL) {
      if (empty($rows['UNIDADE'])) $rows['UNIDADE'] = $this->ConsumoPlanejadoRealizadoController->getUnidades($rows);
      else  $rows['UNIDADE'] = is_array($rows['UNIDADE']) ? join("_", $unidade) : $rows['UNIDADE'];
    } else if ($rows['GRUPFILI'] !== NULL) {
      if (empty($rows['UNIDADE'])) $rows['UNIDADE'] = $this->getUnidadesGrupoServ($rows, $nrorg);  
      else $rows['UNIDADE'] = join("_", $unidade);
    }
    
    if (empty($rows['GRUPOSERVICO'])) $rows['GRUPOSERVICO'] = 'T';   
    if (empty($rows['CDGRUPFILI'])) $rows['CDGRUPFILI'] = 'T';
    
    $query = "SELECT DISTINCT S.CDGRUPSERV, S.CDFILIAL, S.CDSERVFILI, S.NMSERVICO, ( S.CDFILIAL || S.CDSERVFILI ) AS FILISERV, S.NRORG FROM FILIAL      FI, SERVICO     S LEFT JOIN FILGRUPFILI F ON ( S.CDFILIAL = F.CDFILIAL ) WHERE ( FI.CDFILCENTPME = :CDFILCENTPME ) AND ( FI.CDFILIAL = S.CDFILIAL ) AND ( ( INSTR(:CDFILIAL, S.CDFILIAL) <> 0 ) OR ( :CDFILIAL = 'T' ) ) AND ( ( INSTR(:CDGRUPSERV, S.CDGRUPSERV) <> 0 ) OR ( :CDGRUPSERV = 'T' ) ) AND ( ( INSTR(:CDGRUPFILI, F.CDGRUPFILI) <> 0 ) OR ( :CDGRUPFILI = 'T' ) ) ORDER BY S.CDSERVFILI";
    $params = array(
      "CDFILCENTPME" => $rows["CDFILCENTPME"],
      "CDGRUPFILI"   => $rows['CDGRUPFILI'],
      "CDFILIAL"     => $rows['UNIDADE'],
      "CDGRUPSERV"   => $rows['GRUPOSERVICO']
    );
    $stmt = $this->connection->prepare($query);
	  $stmt->execute($params);
    $result = $stmt->fetchAll();
    
    return $result;
  }
  
  public function getCardapio($rows, $nrorg){
    $cdoperador = $this->environment->getCdOperador(); 
    $query = "SELECT CDTIPOCARD, NMTIPOCARD, (CDTIPOCARD || ' - ' || NMTIPOCARD) AS DESCRICAO,  IDTPCARDATIV, NRPASTATCARD, NRORG FROM TIPOCARD WHERE NRORG = :NRORG AND IDTPCARDATIV = 'S' AND CDFILCENTPME = :CDFILCENTPME AND (NRPASTATCARD = :NRPASTATCARD OR :NRPASTATCARD IS NULL) ORDER BY CDTIPOCARD";
    $params = array(
      "NRORG"        => $nrorg,
      "NRPASTATCARD" => NULL,
      "CDFILCENTPME" => $rows["CDFILCENTPME"]
    );
    $stmt = $this->connection->prepare($query);
	  $stmt->execute($params);
    $result = $stmt->fetchAll();
    
    return $result;
  }
  
  public function getUnidadesGrupoServ($rows, $nrorg){
      $cdoperador = $this->environment->getCdOperador(); 
      $unidGrupo = [];
      $query = "SELECT DISTINCT F.CDFILIAL, F.NMFILIAL, F.CDFILIAL || ' - ' || F.NMFILIAL AS DESCRICAO, F.NRORG, F.CDFILCENTPME FROM FILIAL F LEFT JOIN FILGRUPFILI FL ON ( FL.CDGRUPFILI =:CDGRUPFILI OR :CDGRUPFILI = 'T' ) AND FL.NRORG = F.NRORG AND FL.CDFILIAL = F.CDFILIAL WHERE ( FL.CDGRUPFILI IS NOT NULL OR :CDGRUPFILI = 'T' ) AND F.CDFILCENTPME =:CDFILCENTPME AND F.NRORG =:NRORG ORDER BY CDFILIAL";
      $params = array(
        "NRORG"        => $nrorg,
        "CDFILCENTPME" => $rows["CDFILCENTPME"],
        "CDGRUPFILI"   => $rows['GRUPFILI']['CDGRUPFILI']
      );
      $stmt = $this->connection->prepare($query);
		  $stmt->execute($params);
      $result = $stmt->fetchAll();

      foreach($result as $unid){
        array_push($unidGrupo, $unid['CDFILIAL']);
      }
      $resultado = join("_", $unidGrupo);
      return $resultado;
    }
}