<?php
namespace PME\Modules\Planejamento\Prato;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;


class UtilizacaoProdutosController extends \PME\Services\TeknisaCrud {
	protected $crudService;
    protected $parameterBag;
    protected $Lista;
    protected $utilities;

    public function __construct($crudService, $parameterBag, $Lista, $utilities) {
        parent::__construct($crudService, $parameterBag);
        $this->Lista = $Lista;
        $this->utilities = $utilities;
    }
  
    public function retornaListaServ(DTO\Request $request, DTO\Response $response) {
        $nrorg = $this->utilities->getNrOrg();
        $rows = $request->getRow();
    
        $nrlistaserv = '';
        if(count($rows['SERVICO']) > 0) { 
          $servico = $rows['SERVICO'];
        } else {
          $servico = $this->getServicos($rows);
        }
        
        $unidadeServico = '';
        foreach($servico as $servfili) {
          $unidadeServico .= $servfili['CDFILIAL'] . $servfili['CDSERVFILI'] . "_";
        }
        
        $rows['NRLISTASERV'] = $this->Lista->geraLista($unidadeServico, $nrorg);
        $result = $rows['NRLISTASERV'];
	    $response->addDataSet(new DataSet("result", ["data"=> $result]));
	}
  
    public function getServicos($rows) {
        $dataSourceName = 'servicoPorUnidade';
        
        if (empty($rows['UNIDADE'])) $cdfilial = 'T';
        else {
          $unidadeRow = [];
          $cdfilial = join("_", $rows['UNIDADE']);
        }
        
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $cdfilial
            )
        );
        
        $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
        return $result;
    }
}