import { RestDatasource, IRestDatasource } from '@zeedhi/core';

/**
 * Datasource que converte os filtros para o formato esperado pelo backend
 * { name: string, operator: string, value: string }
 */
class PmeDatasource extends RestDatasource implements IRestDatasource {
  /**
   * Retorna todos os parâmetros que serão passados para a URL da requisição
   */
  getRequestParams() {
    this.updateInternalProperties();

    // deixa os filtros no formato esperado pelo backend
    const filter: any = Object.keys(this.filter).map((name) => ({
      name,
      operator: '=',
      value: this.filter[name],
    }));

    return {
      page: this.loadAll ? undefined : this.page,
      limit: this.loadAll ? 1000 : this.limit, // correção para o loadAll
      order: this.order,
      search: this.search || undefined,
      search_in: this.search ? this.searchIn : [],
      find: Object.keys(this.find).length > 0 ? this.find : undefined,
      // in: Object.keys(this.filter),
      ...filter,
    };
  }
}

export { PmeDatasource };
